import { CharacteristicValue as ShelliesCharacteristicValue, Pm1 } from "shellies-ds9";
import { Ability, ServiceClass } from "./base";
/**
 * This ability sets up a custom service that reports power meter readings.
 */
export declare class Pm1Ability extends Ability {
    readonly componentPm1: Pm1;
    /**
     * @param componentPm1 - The switch or cover component to get readings from.
     */
    constructor(componentPm1: Pm1);
    protected get serviceClass(): ServiceClass;
    protected initialize(): void;
    detach(): void;
    /**
     * Handles changes to the `apower` property.
     */
    protected apowerChangeHandler(value: ShelliesCharacteristicValue): void;
    /**
     * Handles changes to the `voltage` property.
     */
    protected voltageChangeHandler(value: ShelliesCharacteristicValue): void;
    /**
     * Handles changes to the `current` property.
     */
    protected currentChangeHandler(value: ShelliesCharacteristicValue): void;
    /**
     * Handles changes to the `aenergy` property.
     */
    protected aenergyChangeHandler(value: ShelliesCharacteristicValue): void;
}
//# sourceMappingURL=pm1.d.ts.map